#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <libgen.h>

#define  MAXDAT 1000000
#define  STRLEN 200
char prog[STRLEN];
int JACK,maxdat;

void get_the_options(int ,char **),usage(char **),locerr(char *);
int main(int argc,char **argv){
  int    ndat=0;
  double O,dO,chi,dchi;
  double *x; int i;
  strcpy(prog,(char *)basename(argv[0]));
  maxdat=-1;JACK=10;
  get_the_options(argc,argv);
  if( maxdat <= 0 ) maxdat = MAXDAT;
  x   = (double *) calloc((size_t) maxdat,(size_t) sizeof(double));
  /*Read data from stdin as long as it fits the array x[].
    ndat counts the number of data. Notice ndat++, not ++ndat!*/
  //while( (ndat<maxdat) && (scanf("%lg",&x[ndat++])==1)){
  //  printf("i= %d x= %f\n",ndat-1,x[ndat-1]);
  //}
  while( scanf("%lg",&x[ndat])==1 ){
    ndat++;
    printf("i= %d x= %f\n",ndat-1,x[ndat-1]);
    if(ndat == maxdat)break;
  }
  //  ndat--;
  //if(ndat <  maxdat )ndat--;//one too many due to reaching end of file
  if(ndat >= maxdat )//we give user a warning if we ignore some data
    fprintf(stderr,"# %s: Warning: Read ndat= %d. Reached the limit %d\n",
	    prog,ndat,maxdat);
  printf("# --------------------------------------------------\n");
  printf("# NDAT = %d data. JACK = %d groups\n",ndat,JACK);//...and print
  for(i=0;i<ndat;i++) printf("%d. %f\n",i,x[i]);
}
/****************************************************************/
void locerr( char *errmes ){
  fprintf(stderr,"%s: %s Exiting....\n",prog,errmes);
  exit(1);
}

#define OPTARGS  "?hj:d:"
void get_the_options(int argc,char **argv){

  int c,errflg = 0;
  while (!errflg && (c = getopt(argc, argv, OPTARGS)) != -1){
    switch(c){
    case 'j':
      JACK = atoi(optarg);
      break;
    case 'd':
      maxdat = atoi(optarg);
      break;
    case 'h':
      errflg++;/*call usage*/
      break;
    default:
      errflg++;
    }/*switch*/
    if(errflg) usage(argv);
  }/*while...*/
}/*get_the_options()*/

void usage(char **argv){
  fprintf(stderr,"\
Usage: %s  [options] <file>\n\
       -j  : No. jack groups Def. 10\n\
       -d  : Give the maximum number of data points read.Def. %d\n\
Computes <o>, chi= (<o^2>-<o>^2)\n\
Data is in one column from stdin.\n",prog,MAXDAT);
  exit(1);
}/*usage()*/
