/************************   measure.c ******************************/
#include "include.h"

void measure(){
  printf ("# MEASURE test: %d %d\n",E()-mon_E,M()-mon_M);
}

int E(){
  int e,sum,i,nn;
  e=0;
  for(i=0;i<N;i++){
    /*Sum of neighboring spins: only forward nn necessary in the sum*/
    if((nn=i+XNN)>= N) nn -= N; sum  = s[nn];
    if((nn=i+YNN)>= N) nn -= N; sum += s[nn];
    e += sum*s[i];
  }
  return -e;
}

int M(){
  int i,m;
  m=0;
  for(i=0;i<N;i++) m+=s[i];
  return m;
}
