#include "nrutil-ext.h"
/* check nrutil-ext.c */

/* Low and High ends */
#define LD 1
#define HD 3

main(int argc, char **argv){

  int i,j,k,l;
  double ****a4;
  double  ***a3;
  double    *a1;
  int       *i1;
  double   **a2;
  int      **i2;

  int L=LD , H=HD;

  if(argc == 3){
    L = atoi(argv[1]);
    H = atoi(argv[2]);
  }

  a4 = cd4tensor(L,H,L,H,L,H,L,H);
  a3 = cd3tensor(L,H,L,H,L,H);
  a1 = cdvector(L,H);
  i1 = civector(L,H);
  a2 = cdmatrix(L,H,L,H);
  i2 = cimatrix(L,H,L,H);
  goto i_2;  /* task to perform */

 a_3:
  for(i=L;i<=H;i++)
    for(j=L;j<=H;j++)
      for(k=L;k<=H;k++){
	  a3[i][j][k] += 1.23;
	  printf("a3[%d][%d][%d]= %lg\n",i,j,k,a3[i][j][k]);
	}
  
  zero_d3tensor(a3,L,H,L,H,L,H);

  for(i=L;i<=H;i++)
    for(j=L;j<=H;j++)
      for(k=L;k<=H;k++)
	  printf("a3[%d][%d][%d]= %lg\n",i,j,k,a3[i][j][k]);

  free_d4tensor(a4,L,H,L,H,L,H,L,H);
  exit(0);

 a_4:
  for(i=L;i<=H;i++)
    for(j=L;j<=H;j++)
      for(k=L;k<=H;k++)
	for(l=L;l<=H;l++){
	  a4[i][j][k][l] += 1.23;
	  printf("a4[%d][%d][%d][%d]= %lg\n",i,j,k,l,a4[i][j][k][l]);
	}

  zero_d4tensor(a4,L,H,L,H,L,H,L,H);
  for(i=L;i<=H;i++)
    for(j=L;j<=H;j++)
      for(k=L;k<=H;k++)
	for(l=L;l<=H;l++)
	  printf("a4[%d][%d][%d][%d]= %lg\n",i,j,k,l,a4[i][j][k][l]);

  free_d4tensor(a4,L,H,L,H,L,H,L,H);
  exit(0);

 a_1:
  for(i=L;i<=H;i++){
    a1[i] += 1.23;
    printf("a1[%d]= %lg\n",i,a1[i]);
  }
  zero_dvector(a1,L,H);
  for(i=L;i<=H;i++){
    printf("a1[%d]= %lg\n",i,a1[i]);
  }
  free_dvector(a1,L,H);
  exit(0);

 i_1:
  for(i=L;i<=H;i++){
    i1[i] += 2;
    printf("i1[%d]= %d\n",i,i1[i]);
  }
  zero_ivector(i1,L,H);
  for(i=L;i<=H;i++){
    printf("i1[%d]= %d\n",i,i1[i]);
  }
  free_ivector(i1,L,H);
  exit(0);

 a_2:
  for(i=L;i<=H;i++)
    for(j=L;j<=H;j++){
      a2[i][j] += 1.23;
      printf("a2[%d][%d]= %lg\n",i,j,a2[i][j]);
    }
  zero_dmatrix(a2,L,H,L,H);
  for(i=L;i<=H;i++)
    for(j=L;j<=H;j++){
      printf("a2[%d][%d]= %lg\n",i,j,a2[i][j]);
    }
  free_dmatrix(a2,L,H,L,H);
  exit(0);

 i_2:
  for(i=L;i<=H;i++)
    for(j=L;j<=H;j++){
      i2[i][j] += 1;
      printf("i2[%d][%d]= %d\n",i,j,i2[i][j]);
    }
  zero_imatrix(i2,L,H,L,H);
  for(i=L;i<=H;i++)
    for(j=L;j<=H;j++){
      printf("i2[%d][%d]= %d\n",i,j,i2[i][j]);
    }
  free_imatrix(i2,L,H,L,H);
  exit(0);
}
